/************************************************************************************/
/*  Program name CAPPOEXT_RECEIPT_HEADER.sql                                        */
/*  Creater:  Kenny, Leung (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 19 Jan 2006, Kenny Leung         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOEXT_RECEIPT_HEADER';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPPO_RECEIPT_HEADER.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT RSH.* 
    FROM   RCV_SHIPMENT_HEADERS RSH,
       HR_ORGANIZATION_UNITS HOU
    WHERE  RSH.SHIP_TO_ORG_ID = HOU.ORGANIZATION_ID
    AND    HOU.NAME LIKE 'IO_'||p_NGO||'%';

BEGIN
	lv_NGO_Name		:=	SUBSTR(UPPER('&1'), -4);

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
        
        lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
        
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			
			UTL_FILE.PUT_LINE(
                  lv_UTL_File,
                  C1.SHIPMENT_HEADER_ID        ||CHR(9)||
                  C1.LAST_UPDATE_DATE          ||CHR(9)||
                  C1.LAST_UPDATED_BY           ||CHR(9)||
                  C1.CREATION_DATE             ||CHR(9)||
                  C1.CREATED_BY                ||CHR(9)||
                  C1.LAST_UPDATE_LOGIN         ||CHR(9)||
                  C1.RECEIPT_SOURCE_CODE       ||CHR(9)||
                  C1.VENDOR_ID                 ||CHR(9)||
                  C1.VENDOR_SITE_ID            ||CHR(9)||
                  C1.ORGANIZATION_ID           ||CHR(9)||
                  C1.SHIPMENT_NUM              ||CHR(9)||
                  C1.RECEIPT_NUM               ||CHR(9)||
                  C1.SHIP_TO_LOCATION_ID       ||CHR(9)||
                  C1.BILL_OF_LADING            ||CHR(9)||
                  C1.PACKING_SLIP              ||CHR(9)||
                  C1.SHIPPED_DATE              ||CHR(9)||
                  C1.FREIGHT_CARRIER_CODE      ||CHR(9)||
                  C1.EXPECTED_RECEIPT_DATE     ||CHR(9)||
                  C1.EMPLOYEE_ID               ||CHR(9)||
                  C1.NUM_OF_CONTAINERS         ||CHR(9)||
                  C1.WAYBILL_AIRBILL_NUM       ||CHR(9)||
                  C1.COMMENTS                  ||CHR(9)||
                  C1.ATTRIBUTE_CATEGORY        ||CHR(9)||
                  C1.ATTRIBUTE1                ||CHR(9)||
                  C1.ATTRIBUTE2                ||CHR(9)||
                  C1.ATTRIBUTE3                ||CHR(9)||
                  C1.ATTRIBUTE4                ||CHR(9)||
                  C1.ATTRIBUTE5                ||CHR(9)||
                  C1.ATTRIBUTE6                ||CHR(9)||
                  C1.ATTRIBUTE7                ||CHR(9)||
                  C1.ATTRIBUTE8                ||CHR(9)||
                  C1.ATTRIBUTE9                ||CHR(9)||
                  C1.ATTRIBUTE10               ||CHR(9)||
                  C1.ATTRIBUTE11               ||CHR(9)||
                  C1.ATTRIBUTE12               ||CHR(9)||
                  C1.ATTRIBUTE13               ||CHR(9)||
                  C1.ATTRIBUTE14               ||CHR(9)||
                  C1.ATTRIBUTE15               ||CHR(9)||
                  C1.USSGL_TRANSACTION_CODE    ||CHR(9)||
                  C1.GOVERNMENT_CONTEXT        ||CHR(9)||
                  C1.REQUEST_ID                ||CHR(9)||
                  C1.PROGRAM_APPLICATION_ID    ||CHR(9)||
                  C1.PROGRAM_ID                ||CHR(9)||
                  C1.PROGRAM_UPDATE_DATE       ||CHR(9)||
                  C1.ASN_TYPE                  ||CHR(9)||
                  C1.EDI_CONTROL_NUM           ||CHR(9)||
                  C1.NOTICE_CREATION_DATE      ||CHR(9)||
                  C1.GROSS_WEIGHT              ||CHR(9)||
                  C1.GROSS_WEIGHT_UOM_CODE     ||CHR(9)||
                  C1.NET_WEIGHT                ||CHR(9)||
                  C1.NET_WEIGHT_UOM_CODE       ||CHR(9)||
                  C1.TAR_WEIGHT                ||CHR(9)||
                  C1.TAR_WEIGHT_UOM_CODE       ||CHR(9)||
                  C1.PACKAGING_CODE            ||CHR(9)||
                  C1.CARRIER_METHOD            ||CHR(9)||
                  C1.CARRIER_EQUIPMENT         ||CHR(9)||
                  C1.CARRIER_EQUIPMENT_NUM     ||CHR(9)||
                  C1.CARRIER_EQUIPMENT_ALPHA   ||CHR(9)||
                  C1.SPECIAL_HANDLING_CODE     ||CHR(9)||
                  C1.HAZARD_CODE               ||CHR(9)||
                  C1.HAZARD_CLASS              ||CHR(9)||
                  C1.HAZARD_DESCRIPTION        ||CHR(9)||
                  C1.FREIGHT_TERMS             ||CHR(9)||
                  C1.FREIGHT_BILL_NUMBER       ||CHR(9)||
                  C1.INVOICE_NUM               ||CHR(9)||
                  C1.INVOICE_DATE              ||CHR(9)||
                  C1.INVOICE_AMOUNT            ||CHR(9)||
                  C1.TAX_NAME                  ||CHR(9)||
                  C1.TAX_AMOUNT                ||CHR(9)||
                  C1.FREIGHT_AMOUNT            ||CHR(9)||
                  C1.INVOICE_STATUS_CODE       ||CHR(9)||
                  C1.ASN_STATUS                ||CHR(9)||
                  C1.CURRENCY_CODE             ||CHR(9)||
                  C1.CONVERSION_RATE_TYPE      ||CHR(9)||
                  C1.CONVERSION_RATE           ||CHR(9)||
                  C1.CONVERSION_DATE           ||CHR(9)||
                  C1.PAYMENT_TERMS_ID          ||CHR(9)||
                  C1.MRC_CONVERSION_RATE_TYPE  ||CHR(9)||
                  C1.MRC_CONVERSION_DATE       ||CHR(9)||
                  C1.MRC_CONVERSION_RATE       ||CHR(9)||
                  C1.SHIP_TO_ORG_ID            ||CHR(9)||
                  C1.CUSTOMER_ID               ||CHR(9)||
                  C1.CUSTOMER_SITE_ID          
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No RCV shipment headers for NGO'; /*Change it for proper error message*/
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

